local TST = select(2,...)
TST = LibStub("AceAddon-3.0"):NewAddon(TST, "TradeSkillTracker", "AceEvent-3.0", "AceConsole-3.0", "AceComm-3.0","AceEvent-3.0")
local AceGUI = LibStub("AceGUI-3.0")
TST.version = GetAddOnMetadata("TradeSkillTracker", "Version")
local WeekDay
local Test_Addon_Opened = false
local TabLayouts = {}

local savedDBDefaults = { --- Default the saved variables
	profile = {

	},
	global = {

	},
	factionrealm = {
		sunday = {},
		monday = {},
		tuesday = {},
		wednesday = {},
		thursday = {},
		friday = {},
		saturday = {},
	},
}

TST:RegisterChatCommand("TST", "Open")

function TST:Open(EXTRA, EXTRA2)
	if EXTRA == "help" or EXTRA == "Help" then
		TST:Print("Following List of Commands are available:\n\/TST - Opens the main window\n\/TST help - Show's Help options\n\/TST Reset - Resets the database of the current items")

	elseif EXTRA == "reset" or EXTRA == "Reset" then
		TST:Print("Resetting all days back to no items")
		TST:ResetDatabase()
	else
		if Test_Addon_Opened == false then
			TSTframe = AceGUI:Create("Frame")
			TSTframe:SetTitle("TradeSkillTracker")
			TSTframe:SetStatusText("TraderSkillTracker Version: V"..TST.version)
			TSTframe:EnableResize(false)
			TSTframe:SetWidth(350)
			TSTframe:SetHeight(400)
			TSTframe:SetCallback("OnClose", function(widget) AceGUI:Release(widget) Test_Addon_Opened = false end)
			TSTframe:SetLayout("Fill")


			local TabbedGroups = AceGUI:Create("TabGroup")
			TabbedGroups:SetLayout("Flow")
			TabbedGroups:SetTabs({{text="Overall", value=1},{text="Monday", value=2},{text="Tuesday", value=3},{text="Wednesday", value=4},{text="Thursday", value=5},{text="Friday", value=6},{text="Saturday", value=7},{text="Sunday", value=8}})
			TabbedGroups:SetCallback("OnGroupSelected", TSTSelectGroup)
			TabbedGroups:SelectTab(1)
			TSTframe:AddChild(TabbedGroups)

			Test_Addon_Opened = true

		elseif Test_Addon_Opened == true then

			Test_Addon_Opened = false
			AceGUI:Release(TSTframe)
		end
	end
end


function TST:OnEnable()
	self:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
	self:RegisterEvent("PLAYER_ENTERING_WORLD")
end

function TST:UNIT_SPELLCAST_SUCCEEDED(EVENTNAME, UNIT, SPELL, RANK, SLID, SID) -- Spell casted Event
	if EVENTNAME ~= "UNIT_SPELLCAST_SUCCEEDED" or UNIT ~= "player" then return end -- Make sure we only track the right event and player
	if string.find(UNIT, '-') then return end --- check for cross realm crafters
	if SPELL == 'Jeeves' or 'Blingtron 4000'then return end --- Handle what happens if jeeves/blingtrong is used while Engineering is open.
	--print(EVENTNAME, UNIT, SPELL, SLID, SID)

	for LISTID=1,GetNumTradeSkills() do -- iterate over the tradeskill
		local name, type, _, _, _, _ = GetTradeSkillInfo(LISTID) -- get info about the current tradeskill
		if name == SPELL  then -- if current tradeskill = casted spell
			local NumReagents = GetTradeSkillNumReagents(LISTID) -- get the reagents
			--TST:Print(NumReagents)
			for i=1, NumReagents, 1 do -- iterate over the reagents
				local reagentName, reagentTexture, reagentCount, playerReagentCount = GetTradeSkillReagentInfo(LISTID, i) -- get reagent info
				--TST:Print(reagentName.." "..reagentCount)
				TST.db.factionrealm[WeekDay][reagentName] = (TST.db.factionrealm[WeekDay][reagentName] or 0) + reagentCount
			end
		end
	end
end

function TST:OnInitialize() --- On addon innitialized
	TST.db = LibStub:GetLibrary("AceDB-3.0"):New("TradeSkillTrackerDB", savedDBDefaults, true)
end


function TST:PLAYER_ENTERING_WORLD()
	local WeekDayNum = select(1,CalendarGetDate())
	--print(WeekDay)
	if WeekDayNum == 1 then
		WeekDay = "sunday"
	elseif WeekDayNum == 2 then
		WeekDay = "monday"
	elseif WeekDayNum == 3 then
		WeekDay = "tuesday"
	elseif WeekDayNum == 4 then
		WeekDay = "wednesday"
	elseif WeekDayNum == 5 then
		WeekDay = "thursday"
	elseif WeekDayNum == 6 then
		WeekDay = "friday"
	elseif WeekDayNum == 7 then
		WeekDay = "saturday"
	end
end

function TSTSelectGroup(container,event,group)
	container:ReleaseChildren()
	if group == 1 then -- Overall
		--print("Overall")
		TST:Overall(container)

	elseif group == 2 then -- monday
		--print("Monday")
		TST:Monday(container)

	elseif group == 3 then -- Tuesday
		--print("Tuesday")
		TST:Tuesday(container)

	elseif group == 4 then -- Wednesday
		--print("Wednesday")
		TST:Wednesday(container)

	elseif group == 5 then -- Thursday
		--print("Thursday")
		TST:Thursday(container)

	elseif group == 6 then -- Friday
		--print("Friday")
		TST:Friday(container)

	elseif group == 7 then -- Saturday
		--print("Saturday")
		TST:Saturday(container)

	elseif group == 8 then -- Sunday
		--print("Sunday")
		TST:Sunday(container)

	end
end

function TST:Overall(container)

	local DAYS
	local Item
	local Ammount

	local ScrollFrame = AceGUI:Create("ScrollFrame")
	ScrollFrame:SetFullWidth(true)
	ScrollFrame:SetFullHeight(true)
	ScrollFrame:SetLayout("Flow")
	container:AddChild(ScrollFrame)

	local HeaderFrame = AceGUI:Create("SimpleGroup")
	HeaderFrame:SetHeight(5)
	HeaderFrame:SetFullWidth()
	HeaderFrame:SetLayout("Flow")
	ScrollFrame:AddChild(HeaderFrame)

	local HeaderTextPlayer = AceGUI:Create("Label")
	HeaderTextPlayer:SetText("Item")
	HeaderTextPlayer:SetRelativeWidth(0.5)
	HeaderTextPlayer:SetFont("DEFAULT", 14, "OUTLINE")
	HeaderFrame:AddChild(HeaderTextPlayer)

	local HeaderTextLevel = AceGUI:Create("Label")
	HeaderTextLevel:SetText("Number")
	HeaderTextLevel:SetRelativeWidth(0.2)
	HeaderTextLevel:SetFont("DEFAULT", 14, "OUTLINE")
	HeaderFrame:AddChild(HeaderTextLevel)

	for DAYS in pairs(TST.db.factionrealm) do
		if DAYS == nil then return end
		for Item, Ammount in pairs(TST.db.factionrealm[DAYS]) do
			--TST:Print(Item, Ammount)

			local HeaderFrame = AceGUI:Create("SimpleGroup")
			HeaderFrame:SetHeight(5)
			HeaderFrame:SetFullWidth()
			HeaderFrame:SetLayout("Flow")
			ScrollFrame:AddChild(HeaderFrame)

			local ItemText = AceGUI:Create("Label")
			ItemText:SetText(Item)
			ItemText:SetRelativeWidth(0.5)
			ItemText:SetFont("DEFAULT", 14, "OUTLINE")
			HeaderFrame:AddChild(ItemText)

			local AmmountText = AceGUI:Create("Label")
			AmmountText:SetText(Ammount)
			AmmountText:SetRelativeWidth(0.2)
			AmmountText:SetFont("DEFAULT", 14, "OUTLINE")
			HeaderFrame:AddChild(AmmountText)
		end
	end
end

function TST:Monday(container)

	local ScrollFrame = AceGUI:Create("ScrollFrame")
	ScrollFrame:SetFullWidth(true)
	ScrollFrame:SetFullHeight(true)
	ScrollFrame:SetLayout("Flow")
	container:AddChild(ScrollFrame)

	local HeaderFrame = AceGUI:Create("SimpleGroup")
	HeaderFrame:SetHeight(5)
	HeaderFrame:SetFullWidth()
	HeaderFrame:SetLayout("Flow")
	ScrollFrame:AddChild(HeaderFrame)

	local HeaderTextPlayer = AceGUI:Create("Label")
	HeaderTextPlayer:SetText("Item")
	HeaderTextPlayer:SetRelativeWidth(0.5)
	HeaderTextPlayer:SetFont("DEFAULT", 14, "OUTLINE")
	HeaderFrame:AddChild(HeaderTextPlayer)

	local HeaderTextLevel = AceGUI:Create("Label")
	HeaderTextLevel:SetText("Number")
	HeaderTextLevel:SetRelativeWidth(0.2)
	HeaderTextLevel:SetFont("DEFAULT", 14, "OUTLINE")
	HeaderFrame:AddChild(HeaderTextLevel)

	TST:GetItems("monday", ScrollFrame)

end

function TST:Tuesday(container)
	local ScrollFrame = AceGUI:Create("ScrollFrame")
	ScrollFrame:SetFullWidth(true)
	ScrollFrame:SetFullHeight(true)
	ScrollFrame:SetLayout("Flow")
	container:AddChild(ScrollFrame)

	local HeaderFrame = AceGUI:Create("SimpleGroup")
	HeaderFrame:SetHeight(5)
	HeaderFrame:SetFullWidth()
	HeaderFrame:SetLayout("Flow")
	ScrollFrame:AddChild(HeaderFrame)

	local HeaderTextPlayer = AceGUI:Create("Label")
	HeaderTextPlayer:SetText("Item")
	HeaderTextPlayer:SetRelativeWidth(0.5)
	HeaderTextPlayer:SetFont("DEFAULT", 14, "OUTLINE")
	HeaderFrame:AddChild(HeaderTextPlayer)

	local HeaderTextLevel = AceGUI:Create("Label")
	HeaderTextLevel:SetText("Number")
	HeaderTextLevel:SetRelativeWidth(0.2)
	HeaderTextLevel:SetFont("DEFAULT", 14, "OUTLINE")
	HeaderFrame:AddChild(HeaderTextLevel)

	TST:GetItems("tuesday", ScrollFrame)

end

function TST:Wednesday(container)
	local ScrollFrame = AceGUI:Create("ScrollFrame")
	ScrollFrame:SetFullWidth(true)
	ScrollFrame:SetFullHeight(true)
	ScrollFrame:SetLayout("Flow")
	container:AddChild(ScrollFrame)

	local HeaderFrame = AceGUI:Create("SimpleGroup")
	HeaderFrame:SetHeight(5)
	HeaderFrame:SetFullWidth()
	HeaderFrame:SetLayout("Flow")
	ScrollFrame:AddChild(HeaderFrame)

	local HeaderTextPlayer = AceGUI:Create("Label")
	HeaderTextPlayer:SetText("Item")
	HeaderTextPlayer:SetRelativeWidth(0.5)
	HeaderTextPlayer:SetFont("DEFAULT", 14, "OUTLINE")
	HeaderFrame:AddChild(HeaderTextPlayer)

	local HeaderTextLevel = AceGUI:Create("Label")
	HeaderTextLevel:SetText("Number")
	HeaderTextLevel:SetRelativeWidth(0.2)
	HeaderTextLevel:SetFont("DEFAULT", 14, "OUTLINE")
	HeaderFrame:AddChild(HeaderTextLevel)

	TST:GetItems("wednesday", ScrollFrame)
end

function TST:Thursday(container)
	local ScrollFrame = AceGUI:Create("ScrollFrame")
	ScrollFrame:SetFullWidth(true)
	ScrollFrame:SetFullHeight(true)
	ScrollFrame:SetLayout("Flow")
	container:AddChild(ScrollFrame)

	local HeaderFrame = AceGUI:Create("SimpleGroup")
	HeaderFrame:SetHeight(5)
	HeaderFrame:SetFullWidth()
	HeaderFrame:SetLayout("Flow")
	ScrollFrame:AddChild(HeaderFrame)

	local HeaderTextPlayer = AceGUI:Create("Label")
	HeaderTextPlayer:SetText("Item")
	HeaderTextPlayer:SetRelativeWidth(0.5)
	HeaderTextPlayer:SetFont("DEFAULT", 14, "OUTLINE")
	HeaderFrame:AddChild(HeaderTextPlayer)

	local HeaderTextLevel = AceGUI:Create("Label")
	HeaderTextLevel:SetText("Number")
	HeaderTextLevel:SetRelativeWidth(0.2)
	HeaderTextLevel:SetFont("DEFAULT", 14, "OUTLINE")
	HeaderFrame:AddChild(HeaderTextLevel)

	TST:GetItems("thursday", ScrollFrame)
end

function TST:Friday(container)
	local ScrollFrame = AceGUI:Create("ScrollFrame")
	ScrollFrame:SetFullWidth(true)
	ScrollFrame:SetFullHeight(true)
	ScrollFrame:SetLayout("Flow")
	container:AddChild(ScrollFrame)

	local HeaderFrame = AceGUI:Create("SimpleGroup")
	HeaderFrame:SetHeight(5)
	HeaderFrame:SetFullWidth()
	HeaderFrame:SetLayout("Flow")
	ScrollFrame:AddChild(HeaderFrame)

	local HeaderTextPlayer = AceGUI:Create("Label")
	HeaderTextPlayer:SetText("Item")
	HeaderTextPlayer:SetRelativeWidth(0.5)
	HeaderTextPlayer:SetFont("DEFAULT", 14, "OUTLINE")
	HeaderFrame:AddChild(HeaderTextPlayer)

	local HeaderTextLevel = AceGUI:Create("Label")
	HeaderTextLevel:SetText("Number")
	HeaderTextLevel:SetRelativeWidth(0.2)
	HeaderTextLevel:SetFont("DEFAULT", 14, "OUTLINE")
	HeaderFrame:AddChild(HeaderTextLevel)

	TST:GetItems("friday", ScrollFrame)
end

function TST:Saturday(container)
	local ScrollFrame = AceGUI:Create("ScrollFrame")
	ScrollFrame:SetFullWidth(true)
	ScrollFrame:SetFullHeight(true)
	ScrollFrame:SetLayout("Flow")
	container:AddChild(ScrollFrame)

	local HeaderFrame = AceGUI:Create("SimpleGroup")
	HeaderFrame:SetHeight(5)
	HeaderFrame:SetFullWidth()
	HeaderFrame:SetLayout("Flow")
	ScrollFrame:AddChild(HeaderFrame)

	local HeaderTextPlayer = AceGUI:Create("Label")
	HeaderTextPlayer:SetText("Item")
	HeaderTextPlayer:SetRelativeWidth(0.5)
	HeaderTextPlayer:SetFont("DEFAULT", 14, "OUTLINE")
	HeaderFrame:AddChild(HeaderTextPlayer)

	local HeaderTextLevel = AceGUI:Create("Label")
	HeaderTextLevel:SetText("Number")
	HeaderTextLevel:SetRelativeWidth(0.2)
	HeaderTextLevel:SetFont("DEFAULT", 14, "OUTLINE")
	HeaderFrame:AddChild(HeaderTextLevel)

	TST:GetItems("saturday", ScrollFrame)
end

function TST:Sunday(container)
	local ScrollFrame = AceGUI:Create("ScrollFrame")
	ScrollFrame:SetFullWidth(true)
	ScrollFrame:SetFullHeight(true)
	ScrollFrame:SetLayout("Flow")
	container:AddChild(ScrollFrame)

	local HeaderFrame = AceGUI:Create("SimpleGroup")
	HeaderFrame:SetHeight(5)
	HeaderFrame:SetFullWidth()
	HeaderFrame:SetLayout("Flow")
	ScrollFrame:AddChild(HeaderFrame)

	local HeaderTextPlayer = AceGUI:Create("Label")
	HeaderTextPlayer:SetText("Item")
	HeaderTextPlayer:SetRelativeWidth(0.5)
	HeaderTextPlayer:SetFont("DEFAULT", 14, "OUTLINE")
	HeaderFrame:AddChild(HeaderTextPlayer)

	local HeaderTextLevel = AceGUI:Create("Label")
	HeaderTextLevel:SetText("Number")
	HeaderTextLevel:SetRelativeWidth(0.2)
	HeaderTextLevel:SetFont("DEFAULT", 14, "OUTLINE")
	HeaderFrame:AddChild(HeaderTextLevel)

	TST:GetItems("sunday", ScrollFrame)
end

function TST:GetItems(DAY, container)
	local DAY = DAY
	local Item
	local Ammount

	for Item, Ammount in pairs(TST.db.factionrealm[DAY]) do
		--TST:Print(Item, Ammount)

		local HeaderFrame = AceGUI:Create("SimpleGroup")
		HeaderFrame:SetHeight(5)
		HeaderFrame:SetFullWidth()
		HeaderFrame:SetLayout("Flow")
		container:AddChild(HeaderFrame)

		local ItemText = AceGUI:Create("Label")
		ItemText:SetText(Item)
		ItemText:SetRelativeWidth(0.5)
		ItemText:SetFont("DEFAULT", 14, "OUTLINE")
		HeaderFrame:AddChild(ItemText)

		local AmmountText = AceGUI:Create("Label")
		AmmountText:SetText(Ammount)
		AmmountText:SetRelativeWidth(0.2)
		AmmountText:SetFont("DEFAULT", 14, "OUTLINE")
		HeaderFrame:AddChild(AmmountText)
	end

end

function TST:ResetDatabase()
	for DAYS in pairs(TST.db.factionrealm) do
		TST.db.factionrealm[DAYS] = {}
	end
end
